'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _parseResourceID = require('../helpers/parseResourceID');

var _parseResourceID2 = _interopRequireDefault(_parseResourceID);

var _QuickAdd = require('../../styles/cspace-input/QuickAdd.css');

var _QuickAdd2 = _interopRequireDefault(_QuickAdd);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = {
  add: _propTypes2.default.func,
  displayName: _propTypes2.default.string,
  formatDestinationName: _propTypes2.default.func,
  formatAddPrompt: _propTypes2.default.func,
  recordTypes: _propTypes2.default.object,
  to: _propTypes2.default.string
};

var defaultProps = {
  formatAddPrompt: function formatAddPrompt(displayName) {
    return 'Add ' + displayName + ' to';
  },
  formatDestinationName: function formatDestinationName(recordTypeConfig, vocabulary) {
    if (vocabulary) {
      return (0, _get2.default)(recordTypeConfig, ['vocabularies', vocabulary, 'messages', 'collectionName', 'defaultMessage']);
    }

    return (0, _get2.default)(recordTypeConfig, ['messages', 'record', 'collectionName', 'defaultMessage']);
  }
};

var QuickAdd = function (_Component) {
  _inherits(QuickAdd, _Component);

  function QuickAdd(props) {
    _classCallCheck(this, QuickAdd);

    var _this = _possibleConstructorReturn(this, (QuickAdd.__proto__ || Object.getPrototypeOf(QuickAdd)).call(this, props));

    _this.handleButtonClick = _this.handleButtonClick.bind(_this);
    return _this;
  }

  _createClass(QuickAdd, [{
    key: 'handleButtonClick',
    value: function handleButtonClick(event) {
      event.preventDefault();

      var _props = this.props,
          add = _props.add,
          displayName = _props.displayName;


      if (add) {
        var _event$currentTarget$ = event.currentTarget.dataset,
            vocabulary = _event$currentTarget$.vocabulary,
            recordType = _event$currentTarget$.recordtype;


        add(recordType, vocabulary, displayName);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props2 = this.props,
          displayName = _props2.displayName,
          formatAddPrompt = _props2.formatAddPrompt,
          formatDestinationName = _props2.formatDestinationName,
          recordTypes = _props2.recordTypes,
          destinationID = _props2.to;


      var destinations = (0, _parseResourceID2.default)(destinationID);

      var buttons = destinations.map(function (destination) {
        var recordType = destination.recordType,
            vocabulary = destination.vocabulary;


        var recordTypeConfig = (0, _get2.default)(recordTypes, recordType);

        if (!recordTypeConfig) {
          return null;
        }

        if (vocabulary) {
          var vocabularyConfig = (0, _get2.default)(recordTypeConfig, ['vocabularies', vocabulary]);

          if (!vocabularyConfig) {
            return null;
          }
        }

        return _react2.default.createElement(
          'li',
          { key: [recordType, vocabulary].join('/') },
          _react2.default.createElement(
            'button',
            {
              'data-recordtype': recordType,
              'data-vocabulary': vocabulary,
              onClick: _this2.handleButtonClick
            },
            formatDestinationName(recordTypeConfig, vocabulary)
          )
        );
      });

      return _react2.default.createElement(
        'div',
        { className: _QuickAdd2.default.common },
        _react2.default.createElement(
          'div',
          null,
          formatAddPrompt(displayName)
        ),
        _react2.default.createElement(
          'ul',
          null,
          buttons
        )
      );
    }
  }]);

  return QuickAdd;
}(_react.Component);

exports.default = QuickAdd;


QuickAdd.propTypes = propTypes;
QuickAdd.defaultProps = defaultProps;